import numpy as np
import Training_data

rng = np.random.default_rng(123)
TEACHDATA = 10000
TESTDATA = 1000
# ETA = 0.5
T_NUMBER = 0


def sigmoid(val):
    return 1 / (1 + np.exp(-val))


def sigmoid_derivative(val):
    return sigmoid(val) * (1 - sigmoid(val))


class PerceptronSGD:
    def __init__(self, input_count, activation=sigmoid, activation_derivative=sigmoid_derivative):
        self.input_count = input_count
        self.activation = activation
        self.activation_derivative = activation_derivative
        self.weights = rng.random(input_count + 1)

    def train(self, ETA, NUM_EPOCHS):
        teach_data = Training_data.make_testset(TEACHDATA)
        for epoch in range(NUM_EPOCHS):
            for i in range(TEACHDATA):
                for j in rng.permutation(len(teach_data)):
                    T = 1 if j == T_NUMBER else 0
                    ix = np.insert(teach_data[j][i].ravel(), 0, 1)
                    z = ix.dot(self.weights)
                    RI = self.activation(z)
                    error = T - RI
                    delta = ETA * error * self.activation_derivative(z) * ix
                self.weights += delta
        return self.weights

    def test(self):
        test_data = Training_data.make_testset(TESTDATA)
        res = [0 for _ in range(len(test_data))]
        for number in range(len(test_data)):
            for sample in test_data[number]:
                ix = np.insert(sample.ravel(), 0, 1)
                res[number] += (self.activation(ix.dot(self.weights)))
        return res
