# README
# Threshold perceptron stagnates although not very accurate so the line
# for ending the training on the threshold early was commented out.
# Plot was added but commented out as the plots that happen too frequently cause an error.

import Function
import numpy as np
from prettytable import PrettyTable
import Perceptrons

# Define the table
table = PrettyTable()


trial_data = Perceptrons.test_data
REPETION = 1


def run_test(neuron, learning_rate, titel):
    global table
    table = PrettyTable()
    table.field_names = ["ETA", "0", "1", "2", "3", "4", "5", "6"]
    for ETA in learning_rate:  # the list of values for ETA
        neuron.train(ETA)
        res = [0] * len(trial_data)
        for i, n_digits in enumerate(trial_data):
            for trial_array in n_digits:
                res[i] = res[i] + round(abs(neuron.test(trial_array)))
        res = ["{:5d}".format(r) for r in res]
        table.add_row([ETA] + res)
        # neuron.plot_errors(titel + f"{ETA}")
    print(table)
    return neuron


x = Function.Variable('x')
ex = Function.Exponent(x)
emx = Function.Exponent(-x)

tanhx = (ex - emx)/(ex + emx)
sigmoid = 1/(1 + ex)
swish = x * sigmoid

for i in range(7):
    Perceptrons.T_NUMBER = i
    E = np.array([0.05, 0.1, 0.2, 0.4, 0.75, 1, 2, 5])
    print("Threshold Perceptron is looking for: ", Perceptrons.T_NUMBER)
    run_test(Perceptrons.ThresholdPerceptron(20), E/4, f"Threshold Perceptron digit {i} ")
    print("Linear Perceptron is looking for: ", Perceptrons.T_NUMBER)
    run_test(Perceptrons.LinearPerceptron(20), E / 160, f"Linear Perceptron digit {i} ")
    print("Sigmoid Gradient Descent Perceptron is looking for: ", Perceptrons.T_NUMBER)
    run_test(Perceptrons.SGDPerceptron(20), E, f"SGD Perceptron digit {i} ")


for i in range(7):
    Perceptrons.T_NUMBER = i
    E = np.array([0.05, 0.1, 0.2, 0.4, 0.75, 1, 2, 5])
    print("Tanh Function Perceptron is looking for: ", Perceptrons.T_NUMBER)
    run_test(Perceptrons.Perceptron(20, tanhx), E / 10, f"Tanh Function  Perceptron digit {i} ")
    print("Sigmoid Function Perceptron is looking for: ", Perceptrons.T_NUMBER)
    run_test(Perceptrons.Perceptron(20, sigmoid), E / 4, f"Sigmoid Function Perceptron digit {i} ")
    print("Swish Function Perceptron is looking for: ", Perceptrons.T_NUMBER)
    run_test(Perceptrons.Perceptron(20, swish), E / 20, f"Swish Function Perceptron digit {i} ")
