

from z3 import *

s = Solver()
am, br, ca, ir = Ints('am br ca ir')  # american, british, canadian, irish
but, dol, hor, tur = Ints('but dol hor tur')  # butterflies, dolphins, horses, turtles
bow, han, swi, ten = Ints('bow han swi ten')  # bowling, handball, swimming, tennis)
black, blue, red, white = Ints('black blue red white')
s.add([And(1 <= x, x <= 4) for x in [ am, br, ca, ir,
                                      but, dol, hor, tur,
                                      bow, han, swi, ten,
                                      black, blue, red, white]])
s.add(Distinct([am, br, ca, ir]))
s.add(Distinct([but, dol, hor, tur]))
s.add(Distinct([bow, han, swi, ten]))
s.add(Distinct([black, blue, red, white]))
s.add(Or((bow + 3 == swi), (bow == swi + 3)))
s.add(han + 2 == ir)
s.add(black == 2)
s.add(hor + 2 == red)
s.add(tur == am + 1)
s.add(bow > ten)
s.add(han + 2 == white)

while s.check() == sat:
    model = s.model()
    print(model)
    block = []
    print("----------------------------------------------")
    for d in model:
        # create a negation of the current solution
        block.append(d() != model[d])
    # add the negation as a new constraint
    s.add(Or(block))
